"""

@author: hagen / hauffe
"""

import numpy as np
from shape import Shape


class Plane(Shape):

   def __init__(self, pos, normal):

       super().__init__()

       self.pos = pos
       self.normal = normal / np.linalg.norm(normal)

   def intersect(self, ray):


       dotp = np.dot(ray.d, self.normal)

       if(dotp >= 0):
           return False

       l = -(np.dot(ray.o - self.pos, self.normal)) / dotp

       # print("l: " + str(l))
       # print("ray.t " + str(ray.t))

       if 0 < l < ray.t:
           ray.t = l
           ray.hit = ray.o + ray.d * ray.t
           ray.n = self.normal
           return True

       return False
   